IndexUpdateReducer (Hadoop 0.20.2+320 API)
Date: 2010-06-28

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.hadoop.contrib.index.mapred
Class IndexUpdateReducer

    java.lang.Object
      org.apache.hadoop.mapred.MapReduceBase
          org.apache.hadoop.contrib.index.mapred.IndexUpdateReducer

All Implemented Interfaces:
  Closeable, JobConfigurable, Reducer<Shard,IntermediateForm,Shard,Text>

    public class IndexUpdateReducer

extends MapReduceBase
implements Reducer<Shard,IntermediateForm,Shard,Text>

This reducer applies to a shard the changes for it. A "new version" of a shard is created at the end of a reduce. It is important to note that the new version of the shard is not derived from scratch. By leveraging Lucene's update algorithm, the new version of each Lucene instance will share as many files as possible as the previous version.

Constructor Summary
`IndexUpdateReducer()`

Method Summary
`void` | `close()` Default implementation that does nothing.
`void` | `configure(JobConf job)` Default implementation that does nothing.
`static Class<? extends WritableComparable>` | `getOutputKeyClass()` Get the reduce output key class.
`static Class<? extends Writable>` | `getOutputValueClass()` Get the reduce output value class.
`void` | `reduce(Shard key, Iterator<IntermediateForm> values, OutputCollector<Shard,Text> output, Reporter reporter)` Reduces values for a given key.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IndexUpdateReducer

    public IndexUpdateReducer()

Method Detail

### getOutputKeyClass

    public static Class<? extends WritableComparable> getOutputKeyClass()

  Get the reduce output key class.

  Returns:
    the reduce output key class

### getOutputValueClass

    public static Class<? extends Writable> getOutputValueClass()

  Get the reduce output value class.

  Returns:
    the reduce output value class

### reduce

    public void reduce(Shard key,
                       Iterator<IntermediateForm> values,
                       OutputCollector<Shard,Text> output,
                       Reporter reporter)
                throws IOException

  Description copied from interface: `Reducer`
  Reduces values for a given key.

  The framework calls this method for each `<key, (list of values)>` pair in the grouped inputs. Output values must be of the same type as input values. Input keys must not be altered. The framework will reuse the key and value objects that are passed into the reduce, therefore the application should clone the objects they want to keep a copy of. In many cases, all values are combined into zero or one value.

  Output pairs are collected with calls to `OutputCollector.collect(Object,Object)`.

  Applications can use the `Reporter` provided to report progress or just indicate that they are alive. In scenarios where the application takes an insignificant amount of time to process individual key/value pairs, this is crucial since the framework might assume that the task has timed-out and kill that task. The other way of avoiding this is to set mapred.task.timeout to a high-enough value (or even zero for no time-outs).

  Specified by:
    `reduce` in interface `Reducer<Shard,IntermediateForm,Shard,Text>`
  Parameters:
    `key` - the key.
    `values` - the list of values to reduce.
    `output` - to collect keys and combined values.
    `reporter` - facility to report progress.
  Throws:
    `IOException`

### configure

    public void configure(JobConf job)

  Description copied from class: `MapReduceBase`
  Default implementation that does nothing.

  Specified by:
    `configure` in interface `JobConfigurable`
  Overrides:
    `configure` in class `MapReduceBase`
  Parameters:
    `job` - the configuration

### close

    public void close()
               throws IOException

  Description copied from class: `MapReduceBase`
  Default implementation that does nothing.

  Specified by:
    `close` in interface `Closeable`
  Overrides:
    `close` in class `MapReduceBase`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 The Apache Software Foundation